#include <exports.h>
#include <common.h>
#include <../include/asm-blackfin/arch-bf537/cdefBF537.h>


#include "test.h"


int bfin_cycles(void)
{
        int ret;

         __asm__ __volatile__("%0 = CYCLES;\n\t"
                   :"=d"(ret));

          return ret;
}


void jtag_init_bfin_port(void)
{
        //enable gpio
         *pPORTG_FER &= ~(TMS_BIT | TDI_BIT | TCK_BIT | TDO_BIT);
        // set TMS, TDI, TCK as outputs and TDO as input
        *pPORTGIO_DIR  |= TMS_BIT | TDI_BIT | TCK_BIT;
        *pPORTGIO_DIR  &= ~(TDO_BIT);
        *pPORTGIO_INEN |= TDO_BIT;

}

//32 bit FPGA -> BF
void jtag_clock_in_long(unsigned long *val)
{
	int i;

	TDI(0);

	for (i = 0; i<31; i++)
	{
		(*val) += (TDO_DATA << 31);
		(*val) >>=1;
		
		TCK_TOGGLE;
	}

	(*val) += (TDO_DATA << 31);
	
	TCK_TOGGLE;
	
	
}



void jtag_enter_dr_state(void)
{
	//run-test/idle
	TMS_SET;
	TCK_TOGGLE; //select dr-scan
	TMS_CLEAR;
	TCK_TOGGLE; //capture-dr
	TCK_TOGGLE; //shift-dr

}

void jtag_leave_dr_state(void)
{
    //shift - dr
	TMS_SET;
	TCK_TOGGLE;
	TMS_CLEAR;
	TCK_TOGGLE;
}



void jtag_issue_inst(unsigned char nBits, unsigned short inst)
{
         //enter ir state

        //run test idle state
        TMS_SET;
        TCK_TOGGLE; //select dr-scan
        TCK_TOGGLE; //select ir-scan

        TMS_CLEAR;
        TCK_TOGGLE; //capture-ir
        TCK_TOGGLE; //shift-ir


        //read instruction bit from LSB to MSB and set TDI
        while(nBits <= (char)IR_LEN)
       {
                TDI(inst&0x1c);
                TCK_TOGGLE;
                inst >>= 1;
        }
        TMS_SET;
        TDI(inst&0x1c);
        TCK_TOGGLE; //exit-ir

        //leave ir state
        TMS_CLEAR;
        TCK_TOGGLE; //pause-ir

}

void jtag_enter_to_idle(void)

{
          // pause - ir
          TMS_SET;
          TCK_TOGGLE;
          TCK_TOGGLE;

          TMS_CLEAR;
          TCK_TOGGLE;

}




unsigned char cfg_in_data[]={0xFF,0xFF,0xFF,0xFF,
                             0x55,0x99,0xAA,0x66,
                             0xc0,0x00,0x10,0x08,
                             0x00,0x00,0x00,0x0e,
                             0x00,0x00,0x00,0x00,
                             0x00,0x00,0x00,0x00};





unsigned char Buffer[] =
{
	0xFF, 0xFF, 0xFF, 0xFF,
 0x55, 0x99, 0xAA, 0x66,
 0x14, 0x00, 0x07, 0x80,	
 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00,	
 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00
};



void jtag_clock_out_bytes_lsb (unsigned char *p, unsigned int bytes)
{
	/*
	int i;
	for (i=0; i<bytes; i++) {
		jtag_clock_out_byte_lsb(p[i]);
	}
	return;
	*/
	asm volatile (
		
		"R0 = %0;\n\t"   //pointer
		"P3 = R0;"
		
		"R0=%1;"    //count
		"P4=R0;"
		
		"R2=0x2800 (X);\n\t"  // TMS TCK
		"R3=0x2000 (X);\n\t"  // TCK

		"P0.H=0xffc0;\n\t"  // PORTFIO_CLEAR
		"P0.L=0x704;\n\t" 

		"P1.H=0xffc0;\n\t"  //PORTFIO_SET
		"P1.L=0x708;\n\t" 


		"P2=8;\n\t"
		
		"LSETUP(3f, 4f) LC1 = P4;\n\t" //clock out bytes
				"3:"
				"R0=B[P3++];"
		
		
				"LSETUP(1f, 2f) LC0 = P2;\n\t" //clock out bits
						"1:\n\t"
						"W[P0]=R2;\n\t"  //TMS_CLEAR TCK_CLEAR
		
						"R0 = ROT R0 BY -1;\n\t" 
		
						"R1=CC;\n\t" 
						"R1<<=0xb;\n\t" 
						"W[P1]=R1;\n\t"  //TMS_SET
						"2:\n\t"
						"W[P1]=R3;\n\t"  //TCK_SET

				"4:"
				"NOP;"

				
		"W[P0]=R3;"  //TCK_CLEAR
		

		:
		: "r"(p), "r"(bytes)
		: "R0", "R1", "R2", "R3", "P0", "P1", "P2", "P3", "P4"
	);
}




void jtag_clock_out_bytes_msb (unsigned char *p, unsigned int bytes)
{
	/*
	int i;
	for (i=0; i<bytes; i++) {
		jtag_clock_out_byte_msb(p[i]);
	}
	*/
	
	asm volatile (
		
		"R0 = %0;\n\t"   //pointer
		"P3 = R0;"
		
		"R0=%1;"    //count
		"P4=R0;"
		
		"R2=0x2800 (X);\n\t"  // TMS TCK
		"R3=0x2000 (X);\n\t"  // TCK

		"P0.H=0xffc0;\n\t"  // PORTFIO_CLEAR
		"P0.L=0x704;\n\t" 

		"P1.H=0xffc0;\n\t"  //PORTFIO_SET
		"P1.L=0x708;\n\t" 


		"P2=8;\n\t"
		
		"LSETUP(3f, 4f) LC1 = P4;\n\t" //clock out bytes
				"3:"
				"R0=B[P3++];"
				//"R0 = ROT R0 BY 24;\n\t" //shift 8th bit of byte to 32nd position in register...
				"R0 <<= 24;"           //...same effect
		
				"LSETUP(1f, 2f) LC0 = P2;\n\t" //clock out bits
						"1:\n\t"
						"W[P0]=R2;\n\t"  //TMS_CLEAR TCK_CLEAR
		
						"R0 = ROT R0 BY 1;\n\t"
		
						"R1=CC;\n\t" 
						"R1<<=0xb;\n\t" 
						"W[P1]=R1;\n\t"  //TMS_SET
						"2:\n\t"
						"W[P1]=R3;\n\t"  //TCK_SET

		
				"4:"
				"NOP;"
				
				
		"W[P0]=R3;"  //TCK_CLEAR
		

		:
		: "r"(p), "r"(bytes)
		: "R0", "R1", "R2", "R3", "P0", "P1", "P2", "P3", "P4"
	);
}

void fpga_get_code (unsigned long *val, unsigned char cmd)
{
	jtag_issue_inst(IR_LEN, cmd);
	jtag_enter_dr_state();
	
	jtag_clock_in_long(val);

	jtag_leave_dr_state();
}



void fpga_get_status(unsigned long *val)
{
	static const long BUF_LEN = 32;
	
	
	jtag_issue_inst(IR_LEN, IR_CFG_IN);
	
	jtag_enter_dr_state();
	jtag_clock_out_bytes_lsb (Buffer, BUF_LEN);
	jtag_leave_dr_state();
	
	jtag_issue_inst(IR_LEN, IR_CFG_OUT);
	
	jtag_enter_dr_state();
	jtag_clock_in_long(val);
	jtag_leave_dr_state();
}




int main( int arg, char *argv[])
{


	*pPORTG_FER &= ~(TDI_BIT | TMS_BIT | TCK_BIT | TDO_BIT);
	
	
	// set PORTF direction register
	*pPORTGIO_DIR |= TDI_BIT | TMS_BIT | TCK_BIT;
	*pPORTGIO_DIR &= ~(TDO_BIT);
	
	*pPORTGIO_INEN |= TDO_BIT;
	


	*pPORTGIO_CLEAR = TDI_BIT | TMS_BIT | TCK_BIT;
	
	
	

	printf("0x%X\n",*pPORTGIO);

# if 0
  // LEDs (PF2..PF7 AND PF15) as Output

   printf (" Pins Aktivation \n");

     while(1)
{
      if(arg < 2)
       {
         *pPORTGIO_SET = 0x0040;
        }
      if(arg >= 2) 
       {

     *pPORTGIO_TOGGLE = (unsigned int)simple_strtoul(argv[1], 0, 16);   // LED on


       }


   while(!tstc()){}
   //(void)getch();



}
#endif

return 0;


}

